#!/usr/bin/env python3
"""
Makeself extractor
by Javantea
Improved Nov 18, 2015
Nov 4, 2015

TODO: Automatically find the correct offset using search for \x1f

gzip -l ~/dls/Skullgirls-1.0.tgz
         compressed        uncompressed  ratio uncompressed_name
         1939929076               29594 -6555043.1% /home/jvoss/dls/Skullgirls-1.0.tar

Silly gzip.

mkdir makeself && cd makeself && tar xvf ~/dls/Skullgirls-1.0.tgz
./
./startmojo.sh
./bin/
./bin/linux/
./bin/linux/x86_64/
./bin/linux/x86_64/guis/
./bin/linux/x86_64/guis/libmojosetupgui_gtkplus2.so
./bin/linux/x86_64/guis/libmojosetupgui_ncurses.so
./bin/linux/x86_64/mojosetup
./bin/linux/x86/
./bin/linux/x86/guis/
./bin/linux/x86/guis/libmojosetupgui_gtkplus2.so
./bin/linux/x86/guis/libmojosetupgui_ncurses.so
./bin/linux/x86/mojosetup

gzip: stdin: decompression OK, trailing garbage ignored
tar: Child returned status 2
tar: Error is not recoverable: exiting now

Only gives us the mojosetup, not the game.

offset=`head -n 395 "$1" | wc -c | tr -d " "`
filesizes="411556"
"""
from __future__ import print_function
import os.path
import sys
import re

filesizes_re = re.compile('filesizes="([^"]*)"')
filename = os.path.expanduser('~/dls/Skullgirls-1.0.sh')
filesize = None
if len(sys.argv) > 1:
	filename = sys.argv[1]
#end if
if len(sys.argv) > 2:
	filesize = int(sys.argv[2])
#end if
a = open(filename, 'rb')
# smallest possible script (see darwinia-full-1.3.0.sh)
script_len = 10 #10240+90
script = a.read(script_len).decode('utf-8')
more = a.read(8)
if more[:1] != b'\x1f':
	while b'\x1f' not in more:
		x = a.read(4096)
		if x == b'': break
		more += x
	#loop
	if b'\x1f' not in more:
		print("Tar.gz not found. Maybe not a makeself?")
		exit(1)
	#end if
	gzip_pos = more.index(b'\x1f')
	script += more[:gzip_pos].decode('utf-8')
	script_len += gzip_pos
#end if
if filesize == None:
	script_filesize = filesizes_re.search(script)
	if script_filesize == None:
		print("Lack of filesize makes this harder. Set the second variable.")
		exit(1)
	#end if
	filesize_data = script_filesize.groups(1)[0]
	filesize = [int(x) for x in filesize_data.split(' ')]
	if len(filesize) == 1:
		filesize = filesize[0]
	#end if
#end if
print(script, end='')
print(script_len, filesize, file=sys.stderr)
a.seek(script_len)
if isinstance(filesize, list):
	for i, filesize_i in enumerate(filesize):
		open(filename + ('.mojosetup%i.tgz' % i), 'wb').write(a.read(filesize_i))
	#next i
else:
	open(filename + '.mojosetup.tgz', 'wb').write(a.read(filesize))
#end if
open(filename + '.zip', 'wb').write(a.read())

